classdef AR1 < Model
    %UNTITLED3 Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        Name        % String name for model class
        Dimension   % Number of variables in model
        NumPars     % Number of parameters in model
        NumFreePars % Number of freely varying parameters
        RHS  % Right hand side variable 
        LHS  % Left hand side variable
    end
    
    properties(Access = private)
        Pars % Parameters
    end
  
    methods
        function this = AR1()
            this.Name      = 'Autoregression';
            this.Dimension = 1;
            this.NumPars   = 1;
        end
        function estimate(this)
            X   = this.LHS;
            X_1 = this.RHS;
            rho_hat = X_1\X;
            this.Pars = rho_hat;
        end
        function [data] = generate(this,innovations)
            T    = size(innovations,1);
            eps  = innovations;
            rho  = this.Pars;
            X    = zeros(T,1);
            for i = 1:T-1
                X(i+1) = rho*X(i) + eps(i);
            end
            X = X(2:end,1);
            data = X;
        end
    end
    
    % I/O Methods
    methods
        function setPars(this,par)
            this.Pars = par;
        end
        function setData(this,X)
            [this.LHS,this.RHS] = getARdata(X,1);
        end
        function [pars] = getPars(this)
            pars = this.Pars;
        end
        function [vP] = getVectorPars(this)
            vP = this.Pars;
        end
        function [vP] = getVectorFreePars(this)
            vP = this.Pars;
        end
    end   
    
end

