classdef Simulation < handle
    %UNTITLED8 Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        Rep     % Number of simulation replications
        Seed    % Seed for simulation experiment
        Dgp     % Model object serving as gdp
        Model   % Model object serving as estimation object
        ParDist % Matrix of simulated parameter values
    end
    
    methods
        function this = Simulation(modelobj,dgpobj,rep)
            this.Model = modelobj;
            this.Dgp   = dgpobj;
            this.Rep   = rep;
        end
        function simParDist(this)
            modeli  = this.Model;
            dgpi    = this.Dgp;
            np      = this.Model.NumPars;
            sims    = this.Rep;
            pardist = zeros(np,sims);
            dim     = modeli.Dimension;
            
            if(matlabpool('size')==0)
                matlabpool open
            end
            
            tic
            disp(datestr(now))
            disp('Running simulation')
            parfor i = 1:sims
                dgp   = dgpi;
                model = modeli;
                eps   = randn(100,dim); % Maybe this step should be objectified in some way
                X     = dgp.generate(eps);
                model.setData(X);
                model.estimate();
                pardist(:,i) = model.getVectorPars();
            end
            disp('Done');
            toc
            
            this.ParDist = pardist;
        end
    end
end
